-- by modelleicher / se7en

-- www.schwabenmodding.bplaced.net - modelleicher - 

-- Version 1.0 - release:  16.04.2014 by modelleicher
-- Version 2.0 - release:  27.02.2015 by se7en - LS15 ready - 
-- Version 3.0 - release:  28.04.2015 by se7en - Saatgut, Dünger, Kalk hinzu gefügt - 
-- Version 3.1 - release:  28.04.2015 by se7en - lua Fix - 

consoleExtension = {};

function consoleExtension:loadMap(name)
	self.dk = false;
	self.fov = 60;
	self.lastTimeSnapShots = 0;
	self.sPath = getUserProfileAppPath();
	self.sPath = self.sPath .. "screenshots/"
	self.sNumber = 0;
	self.sAllNumber = getFiles(self.sPath, "");
	self.time = 0;
end;
function consoleExtension:keyEvent(unicode, sym, modifier, isDown)
end;
function consoleExtension:update(dt)
	if consoleExtensionFirstTimeRun == nil then
		-- gsSetPlayerWalkspeed
		self.defaultPlayerWalkSpeed = g_currentMission.player.walkingSpeed;	
		consoleExtensionFirstTimeRun = true;
	end;
	if self.dk then
		local x = math.random(10, 120)
		if x < self.fov then
			self.fov = math.max(self.fov - 10, x);
		elseif x > self.fov then
			self.fov = math.min(self.fov + 10, x);
		end;
		setFovy(g_currentMission.player.cameraId, self.fov)		
	elseif self.dk == false then
		setFovy(g_currentMission.player.cameraId, 60)	
		self.dk = nil;
	end;
	if self.doTimedSnapshots then
		self.time = self.time +dt
		if (self.lastTimeSnapShots + self.timedSnapshotsTime) < self.time then -- take snapshot
			saveScreenshot(self.sPath.."fastForwardScreen-"..self.sAllNumber.."-"..self.sNumber..".jpg");	
			self.sNumber = self.sNumber +1;
			print("Timed snapshot taken");
			self.lastTimeSnapShots = self.time;
		end;
	end;
end;
function consoleExtension:draw()
end;
function consoleExtension:deleteMap()
end;
function consoleExtension:mouseEvent(posX, posY, isDown, isUp, button)
end;

--[[ gsMRchangeXMLSettingsTractor 
addConsoleCommand("gsMRchangeXMLSettingsTractor", "", "gsMRchangeXMLSettingsTractor", consoleExtension);
function consoleExtension:gsMRchangeXMLSettingsTractor(xmlPath, hp, topSpeed, reverseSpeed, width, height, maxWeight, weight, brakingDec, awd, maxFuelUsage)
	xmlPath = tostring(xmlPath);
	if xmlPath == "help" or xmlPath == "HELP" then
		print("Following Values are needed:");
		print("xmlPath hp topSpeed reverseSpeed width height maxWeight weight brakingDec allWheelDrive(true/false) maxFuelUsage(optional) ");
	end;	
	-- for debug reasons
	hp = Utils.getNoNil(hp, 100);
	topSpeed = Utils.getNoNil(topSpeed, 50);
	reverseSpeed = Utils.getNoNil(reverseSpeed, 12);
	width = Utils.getNoNil(width, 1800);
	height = Utils.getNoNil(height, 1750);
	maxWeight = Utils.getNoNil(maxWeight, 7600);
	weight = Utils.getNoNil(weight, 4500);
	brakingDec = Utils.getNoNil(brakingDec, 4);
	awd = Utils.getNoNil(awd, true);

	---------------------
	
	width = width / 1000;
	height = height / 1000;
	maxWeight = maxWeight / 1000;
	weight = weight / 1000;
	maxFuelUsage = Utils.getNoNil(maxFuelUsage, (hp*0.736)*0.272);
	if fileExists(xmlPath) then
		local tempXML = loadXMLFile("vehicle", xmlPath);
		--removeXMLProperty(tempXML, "vehicle");
		
		setXMLString(tempXML, "vehicle.testTag#testAttribute", "1>3|1" )
		
		-- remove motor section
		removeXMLProperty(tempXML, "vehicle.motor");
		-- edit accelerationSpeed Section
		setXMLInt(tempXML, "vehicle.accelerationSpeed#maxAcceleration", 1);
		setXMLInt(tempXML, "vehicle.accelerationSpeed#deceleration", 1);
		setXMLInt(tempXML, "vehicle.accelerationSpeed#brakeSpeed", 3);
		removeXMLProperty(tempXML, "vehicle.accelerationSpeed.backwardDeceleration");
		-- fuel usage and downforce
		setXMLInt(tempXML, "vehicle.fuelUsage", 0);
		setXMLInt(tempXML, "vehicle.downForce", 0);
		
		-- now set the mr relevant values
		setXMLFloat(tempXML, "vehicle.bunkerSiloCompactor#compactingScale", 0.25 * weight);
		setXMLFloat(tempXML, "vehicle.realMaxVehicleSpeed", topSpeed);
		setXMLFloat(tempXML, "vehicle.realMaxReverseSpeed", reverseSpeed);
		setXMLFloat(tempXML, "vehicle.realBrakeMaxMovingMass", maxWeight + (maxWeight*0.5));
		setXMLFloat(tempXML, "vehicle.realBrakingDeceleration", brakingDec);
		setXMLFloat(tempXML, "vehicle.realSCX", width*height*0.8*0.85);
		setXMLFloat(tempXML, "vehicle.realPtoPowerKW", (hp*0.736)*0.92);
		setXMLFloat(tempXML, "vehicle.realMaxFuelUsage", maxFuelUsage);
		
		-- now set the realMassWanted
		local compCnt = getXMLInt(tempXML, "vehicle.components#count");
		for i=1, compCnt do
			setXMLFloat(tempXML, "vehicle.components.component"..i.."#realMassWanted", weight / compCnt);
		end;
		
		-- now edit wheel lines
		setXMLFloat(tempXML, "vehicle.wheels#autoRotateBackSpeed", 1);
		local wi = 0;
		while true do
			local check = getXMLString(xmlFile, "vehicle.wheels.wheel("..wi..")#repr");
			if check == "" or check == nil then
				print("check was nil");			
				break;
			end;
			removeXMLProperty(tempXML, "vehicle.wheels.wheel("..wi..")#lateralStiffness");
			removeXMLProperty(tempXML, "vehicle.wheels.wheel("..wi..")#longitudalStiffness");
			if not awd then
				if wi == 0 or wi == 1 then
					setXMLInt(tempXML, "vehicle.wheels.wheel("..wi..")#brakeRatio", 0);
				else
					setXMLInt(tempXML, "vehicle.wheels.wheel("..wi..")#brakeRatio", 1);
				end;
			else
				setXMLInt(tempXML, "vehicle.wheels.wheel("..wi..")#brakeRatio", 1);
			end;
			setXMLInt(tempXML, "vehicle.wheels.wheel("..wi..")#damper", 20);
			local supsTravel = getXMLFloat(tempXML, "vehicle.wheels.wheel("..wi..")suspTravel");
			local deltaY = getXMLFloat(tempXML, "vehicle.wheels.wheel("..wi..")deltaY");
			if suspTravel == "" or suspTravel == nil or suspTravel == 0 or suspTravel < 0.05 then
				suspTravel = 0.08
				setXMLFloat(tempXML, "vehicle.wheels.wheel("..wi..")suspTravel", suspTravel);
			end;
			setXMLFloat(tempXML, "vehicle.wheels.wheel("..wi..")spring", 278 * (maxWeight*0.44) / (suspTravel*100/2));
			if deltaY == "" or deltaY == nil or deltaY == 0 then
				setXMLFloat(tempXML, "vehicle.wheels.wheel("..wi..")deltaY", suspTravel * 0.9);
			end;
			wi = wi +1;
			print("wheels: "..wi);
		end;
		
		saveXMLFile(tempXML);
	else
		print("No File on given Path found");
	end;

end;
-- gsMRremoveDampingsFromI3d
addConsoleCommand("gsMRremoveDampingsFromI3d", "", "gsMRremoveDampingsFromI3d", consoleExtension);
function consoleExtension:gsMRremoveDampingsFromI3d(i3dPath)
	i3dPath = tostring(i3dPath);
	if fileExists(i3dPath) then
		local tempi3d = loadXMLFile("i3D", i3dPath);
		local i = 0;
		while true do
			local check = getXMLString(tempi3d, "i3D.Scene.Shape("..i..")#name")
			if check == "" or check == nil then
				print("check was nil");
				break;
			end;
			local isDynamic = getXMLString(tempi3d, "i3D.Scene.Shape("..i..")#dynamic");
			print(tostring(isDynamic));
			if isDynamic then
				setXMLInt(tempi3d, "i3D.Scene.Shape("..i..")#linearDamping", 0);
				setXMLInt(tempi3d, "i3D.Scene.Shape("..i..")#angularDamping", 0);		
				print("Damping Values changed to 0 on Shape " .. check);
			end;
			i = i+1;
			print(i);
			if i > 100 then
				print("Overflow of 100 dynamic Shapes has reached. If you really have 100 Dynamic Shapes on the i3d.. Not good..");
				break;
			end;
		end;		
		saveXMLFile(tempi3d);
		print("Saved changed i3d File");
	else
		print("No file on given Path found");
	end;
end; ]]--

-- gsAddMoney
addConsoleCommand("gsAddMoney", "Adds money, negative value decreases money value", "gsAddMoney", consoleExtension);
function consoleExtension:gsAddMoney(value)
	if value ~= nil then
		g_currentMission:addSharedMoney(value);	
		print("Addet following Value of Money: " .. tostring(value));
	else
		print("gsAddMoney [value]");
	end;
end;

-- gsOwnAllFields
addConsoleCommand("gsOwnAllFields", "Player owns all fields if this command is entered", "gsOwnAllFields", consoleExtension);
function consoleExtension:gsOwnAllFields()
   g_currentMission:playerOwnsAllFields();
   print("Now all Fields are yours.. Have Fun :) ");
end;

-- gsSetPlayerSpeed
addConsoleCommand("gsSetPlayerSpeed", "Set new Walkspeed of player.", "gsSetPlayerSpeed", consoleExtension);
function consoleExtension:gsSetPlayerSpeed(data)
	if data == "default" or data == "" or data == nil then
		g_currentMission.player.walkingSpeed = self.defaultPlayerWalkSpeed;
		print("Player walkspeed set to: " .. tostring(g_currentMission.player.walkingSpeed) .. " (default value) ");
	else
		g_currentMission.player.walkingSpeed = Utils.getNoNil(data, self.defaultPlayerWalkSpeed);
		print("Player walkspeed set to: " .. tostring(g_currentMission.player.walkingSpeed));
	end;
end;

-- gsCopy
addConsoleCommand("gsCopy", "Copys any given file to any given directory. First Entry is the Source Path, second the Destination Path, third is bool for overwrite if exists.", "gsCopy", consoleExtension);
function consoleExtension:gsCopy(source, destination, overwrite)
	source = tostring(source);
	destination = tostring(destination);
	copyFile(source, destination, overwrite);
	print("gsCopy called");
end;

-- gsAddFruit
addConsoleCommand("gsAddFruit", "Adds given fruit value to given fruittype", "gsAddFruit", consoleExtension);
function consoleExtension:gsAddFruit(fruit, value)
	if fruit ~= nil and value ~= nil then
		if fruit == "wheat" or fruit == "WHEAT" or fruit == "weizen" or fruit == "woiza" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_WHEAT, g_currentMission:getSiloAmount(Fillable.FILLTYPE_WHEAT) + value);
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "barley" or fruit == "BARLEY" or fruit == "gerste" or fruit == "gerschde" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_BARLEY, g_currentMission:getSiloAmount(Fillable.FILLTYPE_BARLEY) + value);	
			print(" addet " .. value .. " to " .. fruit);			
		elseif fruit == "rape" or fruit == "RAPE" or fruit == "raps" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_RAPE, g_currentMission:getSiloAmount(Fillable.FILLTYPE_RAPE) + value);	
			print(" addet " .. value .. " to " .. fruit);			
		elseif fruit == "maize" or fruit == "MAIZE" or fruit == "mais" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_MAIZE, g_currentMission:getSiloAmount(Fillable.FILLTYPE_MAIZE) + value);	
			print(" addet " .. value .. " to " .. fruit);									
		elseif fruit == "potato" or fruit == "POTATO" or fruit == "kartoffel" or fruit == "erdaepfel" or fruit == "krombira" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_POTATO, g_currentMission:getSiloAmount(Fillable.FILLTYPE_POTATO) + value);	
			print(" addet " .. value .. " to " .. fruit);		
		elseif fruit == "sugarBeet" or fruit == "SUGARBEET" or fruit == "rueben" or fruit == "riaba" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_SUGARBEET, g_currentMission:getSiloAmount(Fillable.FILLTYPE_SUGARBEET) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "woodChips" or fruit == "WOODCHIPS" or fruit == "hackschnitzel" or fruit == "gehacktes" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_WOODCHIPS, g_currentMission:getSiloAmount(Fillable.FILLTYPE_WOODCHIPS) + value);	
			print(" addet " .. value .. " to " .. fruit);			
		elseif fruit == "manure" or fruit == "MANURE" or fruit == "mist" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_MANURE, g_currentMission:getSiloAmount(Fillable.FILLTYPE_MANURE) + value);	
			print(" addet " .. value .. " to " .. fruit);			
		elseif fruit == "liquidManure" or fruit == "LIQUIDMANURE" or fruit == "guelle" or fruit == "scheisse" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_LIQUIDMANURE, g_currentMission:getSiloAmount(Fillable.FILLTYPE_LIQUIDMANURE) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "grass_windrow" or fruit == "GRASS" or fruit == "gras" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_GRASS_WINDROW, g_currentMission:getSiloAmount(Fillable.FILLTYPE_GRASS_WINDROW) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "wheat_windrow" or fruit == "STROH" or fruit == "stroh" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_WHEAT_WINDROW, g_currentMission:getSiloAmount(Fillable.FILLTYPE_WHEAT_WINDROW) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "chaff" or fruit == "CHAFF" or fruit == "haeckselgut" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_CHAFF, g_currentMission:getSiloAmount(Fillable.FILLTYPE_CHAFF) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "silage" or fruit == "SILAGE" or fruit == "silage" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_SILAGE, g_currentMission:getSiloAmount(Fillable.FILLTYPE_SILAGE) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "forage" or fruit == "FUTTER" or fruit == "mischfutter" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_FORAGE, g_currentMission:getSiloAmount(Fillable.FILLTYPE_FORAGE) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "seeds" or fruit == "SAATGUT" or fruit == "saatgut" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_SEEDS, g_currentMission:getSiloAmount(Fillable.FILLTYPE_SEEDS) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "fertilizer" or fruit == "DUENGER" or fruit == "duenger" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_FERTILIZER, g_currentMission:getSiloAmount(Fillable.FILLTYPE_FERTILIZER) + value);	
			print(" addet " .. value .. " to " .. fruit);
		elseif fruit == "kalk" or fruit == "KALK" or fruit == "lime" then
			g_currentMission:setSiloAmount(Fillable.FILLTYPE_LIME, g_currentMission:getSiloAmount(Fillable.FILLTYPE_LIME) + value);	
			print(" addet " .. value .. " to " .. fruit);
		end;
	else
		print("gsAddFruit false value or no value was inserted. possible Values: fruitType and value, example 'gsAddFruit wheat 15000' ")
	end;
end;

-- gsIAmDrunk
addConsoleCommand("gsIAmDrunk", "Never a good idea", "gsIAmDrunk", consoleExtension);
function consoleExtension:gsIAmDrunk()
	self.dk = (self.dk == nil) 
end;

-- gsTakeTimedSnapshots
addConsoleCommand("gsTakeTimedSnapshots", "Takes timed Snapshots (for fast forward videos or so, value = time in minutes between the pictures)", "gsTakeTimedSnapshots", consoleExtension);
function consoleExtension:gsTakeTimedSnapshots(timeBetweenSnapshots)
	if timeBetweenSnapshots ~= nil and timeBetweenSnapshots ~= "" and timeBetweenSnapshots ~= "false" then
		self.doTimedSnapshots = true;
		self.timedSnapshotsTime = timeBetweenSnapshots*60*1000; -- minutes to ms
		print("Timed Snapshots enabled. Time between each snapshot: "..tostring(timeBetweenSnapshots).." minutes".." "..tostring(self.timedSnapshotsTime).." miliseconds");
	elseif timeBetweenSnapshots == "" or timeBetweenSnapshots == "false" then
		self.doTimedSnapshots = nil;
		print("Timed Snapshots disabled.");
	end;
end;


-- gsSetTimeScale (not functional now, works fine but some scripts dont like fast forward, so they give errors... -now fixed) 
addConsoleCommand("gsSetTimeScale", "Set any Value for current Timescale", "gsSetTimeScale", consoleExtension);
function consoleExtension:gsSetTimeScale(timescale)
	if timescale ~= "" and timescale ~= nil then
		g_currentMission:setTimeScale(timescale)
	else
		g_currentMission:setTimeScale(5)
	end;
	print("Timescale set to "..tostring(g_currentMission.missionStats.timeScale));
end;

-- lua
addConsoleCommand("runCode", "runs LUA code", "runCode", consoleExtension);
function consoleExtension:runCode(code)
   loadstring(code);
   print("code successfully executed");
end;

addModEventListener(consoleExtension);







